<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.2.0/socket.io.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/apexcharts"></script>    <title>Test</title>
</head>
<body>
    <h1>Printing live values</h1>
    <pre id="live-values"></pre>
    <h2><span>Temperature: </span><span id="temperature-value">...</span> °C</h2>
    <h2><span>Pressure: </span><span id="pressure-value">...</span> mbar</h2>
    <div class="chart-temperature"></div>
    <div class="chart-pressure"></div>
    <script>
        var socket = io()
        var liveValues = document.getElementById('live-values')
        socket.on('connect', function() {
            socket.emit('get_grouped_data', '')
            socket.emit('get_instant_data', '')
        })
        socket.on('send_grouped_data', function(msg) {
            const initialData = msg
            const initialTemperatureData = initialData.map(el => [el[1], el[2]])
            const initialPressureData = initialData.map(el => [el[1], el[3]])
            const lastPoint = initialData[initialData.length - 1]
            document.getElementById('temperature-value').textContent = +lastPoint[2].toFixed(2)
            document.getElementById('pressure-value').textContent = +lastPoint[3].toFixed(2)
            plotData(initialTemperatureData, '.chart-temperature', 'Temperature')
            plotData(initialPressureData, '.chart-pressure', 'Pressure')
        })
        socket.on('send_instant_data', function(msg) {
            const point = msg[0]
            const temperaturePoint = [point[1], point[2]]
            const pressurePoint = [point[1], point[3]]
            document.getElementById('temperature-value').textContent = point[2].toFixed(3)
            document.getElementById('pressure-value').textContent = point[3].toFixed(3)

        })

        function plotData(initialData, className, title) {
            const ranges = {
                '.chart-temperature': [20, 25],
                '.chart-pressure': [940, 960],
            }

            var options = {
                chart: {
                    height: 350,
                    type: 'line',
                    animations: {
                        enabled: true,
                        easing: 'linear',
                        dynamicAnimation: {
                            speed: 2000
                        }
                    },
                    toolbar: {
                        show: true
                    },
                    zoom: {
                        enabled: false
                    }
                },
                dataLabels: {
                    enabled: false
                },
                stroke: {
                    curve: 'smooth'
                },
                series: [{
                    data: initialData
                }],
                title: {
                    text: title,
                    align: 'left'
                },
                markers: {
                    size: 0
                },
                yaxis: {
                    min: ranges[className][0],
                    max: ranges[className][1],
                },
                xaxis: {
                    type: 'datetime',
                    range: 86400000,
                },
                legend: {
                    show: false
                },
            }

            var chart = new ApexCharts(
                document.querySelector(className),
                options
            );

            chart.render();
        }
        
        window.setInterval(function() {
            socket.emit('get_instant_data', '')
        }, 5000)

        window.setInterval(function () {
            socket.emit('get_grouped_data', '')
        }, 300000)
    </script>
</body>
</html>